diff --git a/test/unit/fact_value_test.rb b/test/unit/fact_value_test.rb
index 9e35368..d4be6fd 100644
--- a/test/unit/fact_value_test.rb
+++ b/test/unit/fact_value_test.rb
@@ -2,15 +2,16 @@ require 'test_helper'
 
 class FactValueTest < ActiveSupport::TestCase
   def setup
-    host = Host.create :name => "myfullhost", :mac => "aabbecddeeff", :ip => "123.05.02.03",
-                        :domain => Domain.find_or_create_by_name("company.com"),
-                        :operatingsystem => Operatingsystem.first,
-                        :architecture => Architecture.find_or_create_by_name("i386"),
-                        :environment => Environment.find_or_create_by_name("envy"),
-                        :disk => "empty partition"
-
-    @fact_name = Puppet::Rails::FactName.create(:name => "my_facting_name")
-    @fact_value = FactValue.create(:value => "some value", :host => host, :fact_name => @fact_name)
+    as_admin do
+      @host = Host.create :name => "myfullhost", :mac => "aabbecddeeff", :ip => "123.05.02.03",
+                          :domain => Domain.find_or_create_by_name("company.com"),
+                          :operatingsystem => Operatingsystem.first,
+                          :architecture => Architecture.find_or_create_by_name("i386"),
+                          :environment => Environment.find_or_create_by_name("envy"),
+                          :disk => "empty partition"
+    end
+    @fact_name  = Puppet::Rails::FactName.create(:name => "my_facting_name")
+    @fact_value = FactValue.create(:value => "some value", :host => @host, :fact_name => @fact_name)
   end
 
 #  test "should return the memory average" do
@@ -22,13 +23,15 @@ class FactValueTest < ActiveSupport::TestCase
     assert_equal h, FactValue.count_each("my_facting_name")
 
     #Now creating a new fact value
-    other_host = Host.create :name => "myfullhost2", :mac => "aabbccddeefa", :ip => "123.05.02.04",
-                              :domain => Domain.find_or_create_by_name("company.com"),
-                              :operatingsystem => Operatingsystem.first,
-                              :architecture => Architecture.find_or_create_by_name("i386"),
-                              :environment => Environment.find_or_create_by_name("envy"),
-                              :disk => "empty partition"
-    other_fact_value = FactValue.create(:value => "some value", :host => other_host, :fact_name => @fact_name)
+    as_admin do
+      @other_host = Host.create :name => "myfullhost2", :mac => "aabbccddeefa", :ip => "123.05.02.04",
+                                :domain => Domain.find_or_create_by_name("company.com"),
+                                :operatingsystem => Operatingsystem.first,
+                                :architecture => Architecture.find_or_create_by_name("i386"),
+                                :environment => Environment.find_or_create_by_name("envy"),
+                                :disk => "empty partition"
+    end
+    other_fact_value = FactValue.create(:value => "some value", :host => @other_host, :fact_name => @fact_name)
     h["Some value"] = 2
     assert_equal h, FactValue.count_each("my_facting_name")
   end
diff --git a/test/unit/group_parameter_test.rb b/test/unit/group_parameter_test.rb
index 32b8161..79131d2 100644
--- a/test/unit/group_parameter_test.rb
+++ b/test/unit/group_parameter_test.rb
@@ -1,6 +1,9 @@
 require 'test_helper'
 
 class GroupParameterTest < ActiveSupport::TestCase
+  setup do
+    User.current = User.find_by_login "admin"
+  end
   test "should have a reference_id" do
     group_parameter = GroupParameter.new
     assert !group_parameter.save
@@ -24,5 +27,82 @@ class GroupParameterTest < ActiveSupport::TestCase
     parameter2 = GroupParameter.create :name => "some parameter", :value => "value", :reference_id => Hostgroup.last.id
     assert parameter2.valid?
   end
+
+  def setup_user operation
+    @one = users(:one)
+    as_admin do
+      role = Role.find_or_create_by_name :name => "#{operation}_hostgroups"
+      role.permissions = ["#{operation}_hostgroups".to_sym]
+      @one.roles = [role]
+      @one.hostgroups = []
+      @one.save!
+    end
+    User.current = @one
+  end
+
+  test "user with create permissions should be able to create when permitted" do
+    setup_user "create"
+    as_admin do
+      @one.hostgroups = [hostgroups(:common)]
+    end
+    record =  GroupParameter.create :name => "dummy", :value => "value", :reference_id => hostgroups(:common).id
+    assert record.valid?
+    assert !record.new_record?
+  end
+
+  test "user with create permissions should not be able to create when not permitted" do
+    setup_user "create"
+    as_admin do
+      @one.hostgroups = [hostgroups(:common)]
+    end
+    record =  GroupParameter.create :name => "dummy", :value => "value", :reference_id => hostgroups(:unusual).id
+    assert record.valid?
+    assert record.new_record?
+  end
+
+  test "user with create permissions should be able to create when unconstrained" do
+    setup_user "create"
+    as_admin do
+      @one.hostgroups = []
+    end
+    record =  GroupParameter.create :name => "dummy", :value => "value", :reference_id => hostgroups(:common).id
+    assert record.valid?
+    assert !record.new_record?
+  end
+
+  test "user with view permissions should not be able to create when not permitted" do
+    setup_user "view"
+    record =  GroupParameter.create :name => "dummy", :value => "value", :reference_id => hostgroups(:common).id
+    assert record.valid?
+    assert record.new_record?
+  end
+
+  test "user with destroy permissions should be able to destroy" do
+    setup_user "destroy"
+    record =  GroupParameter.first
+    assert record.destroy
+    assert record.frozen?
+  end
+
+  test "user with edit permissions should not be able to destroy" do
+    setup_user "edit"
+    record =  GroupParameter.first
+    assert !record.destroy
+    assert !record.frozen?
+  end
+
+  test "user with edit permissions should be able to edit" do
+    setup_user "edit"
+    record      =  GroupParameter.first
+    record.name = "renamed"
+    assert record.save
+  end
+
+  test "user with destroy permissions should not be able to edit" do
+    setup_user "destroy"
+    record      =  GroupParameter.first
+    record.name = "renamed"
+    assert !record.save
+  end
 end
 
diff --git a/test/unit/host_mailer_test.rb b/test/unit/host_mailer_test.rb
index e08668e..eabc52a 100644
--- a/test/unit/host_mailer_test.rb
+++ b/test/unit/host_mailer_test.rb
@@ -2,18 +2,20 @@ require 'test_helper'
 
 class HostMailerTest < ActionMailer::TestCase
   def setup
-    @env = Environment.new :name => "testing"
-    @env.save!
-
-    @host = Host.new :name => "myfullhost", :mac => "aabbecddeeff", :ip => "123.05.02.03",
-      :domain => Domain.find_or_create_by_name("company.com"), :operatingsystem => Operatingsystem.first,
-      :architecture => Architecture.first, :environment => @env, :disk => "empty partition",
-      :ptable => Ptable.first, :last_report => Time.at(0)
-    @host.save!
-
-    @env.hosts << @host
-    @env.save!
-
+    as_admin do
+      @env = Environment.new :name => "testing"
+      @env.save!
+  
+      @host = Host.new :name => "myfullhost", :mac => "aabbecddeeff", :ip => "123.05.02.03",
+        :domain => Domain.find_or_create_by_name("company.com"), :operatingsystem => Operatingsystem.first,
+        :architecture => Architecture.first, :environment => @env, :disk => "empty partition",
+        :ptable => Ptable.first, :last_report => Time.at(0)
+      @host.save!
+  
+      @env.hosts << @host
+      @env.save!
+    end
+    User.current = User.find_by_login "admin"
     SETTINGS[:foreman_url] = "http://localhost:3000/hosts/:id"
 
     @options = {}
diff --git a/test/unit/host_parameter_test.rb b/test/unit/host_parameter_test.rb
index 5adcb36..9b695a8 100644
--- a/test/unit/host_parameter_test.rb
+++ b/test/unit/host_parameter_test.rb
@@ -1,6 +1,9 @@
 require 'test_helper'
 
 class HostParameterTest < ActiveSupport::TestCase
+  setup do
+    User.current = User.find_by_login "admin"
+  end
   test "should have a reference_id" do
     host_parameter = HostParameter.new
     host_parameter.name = "valid"
@@ -13,28 +16,111 @@ class HostParameterTest < ActiveSupport::TestCase
   end
 
   test "duplicate names cannot exist for a host" do
-    host = Host.create :name => "myfullhost", :mac => "aabbecddeeff", :ip => "123.05.02.03",
-    :domain => domains(:mydomain) , :operatingsystem => Operatingsystem.first, :hostgroup => hostgroups(:common),
-    :architecture => Architecture.first, :environment => Environment.first, :disk => "empty partition"
+    as_admin do
+      @host = Host.create! :name => "myfullhost", :mac => "aabbecddeeff", :ip => "123.05.02.03",
+                          :domain => domains(:mydomain) , :operatingsystem => Operatingsystem.first, :hostgroup => hostgroups(:common),
+                          :architecture => Architecture.first, :environment => Environment.first, :disk => "empty partition"
 
-    parameter1 = HostParameter.create :name => "some parameter", :value => "value", :reference_id => host.id
-    parameter2 = HostParameter.create :name => "some parameter", :value => "value", :reference_id => host.id
-    assert !parameter2.valid?
-    assert  parameter2.errors.full_messages[0] == "Name has already been taken"
+      @parameter1 = HostParameter.create :name => "some parameter", :value => "value", :reference_id => @host.id
+      @parameter2 = HostParameter.create :name => "some parameter", :value => "value", :reference_id => @host.id
+    end
+    assert !@parameter2.valid?
+    assert  @parameter2.errors.full_messages[0] == "Name has already been taken"
   end
 
   test "duplicate names can exist for different hosts" do
-    host1 = Host.create :name => "myfullhost", :mac => "aabbecddeeff", :ip => "123.05.02.03",
-    :domain => domains(:mydomain) , :operatingsystem => Operatingsystem.first, :hostgroup => hostgroups(:common),
-    :architecture => Architecture.first, :environment => Environment.first, :disk => "empty partition"
-    host2 = Host.create :name => "anotherfullhost", :mac => "aabbecddee00", :ip => "123.05.02.04",
-    :domain => domains(:mydomain) , :operatingsystem => Operatingsystem.first, :hostgroup => hostgroups(:common),
-    :architecture => Architecture.first, :environment => Environment.first, :disk => "empty partition"
+    as_admin do
+      @host1 = Host.create! :name => "myfullhost", :mac => "aabbecddeeff", :ip => "123.05.02.03",
+                            :domain => domains(:mydomain) , :operatingsystem => Operatingsystem.first, :hostgroup => hostgroups(:common),
+                            :architecture => Architecture.first, :environment => Environment.first, :disk => "empty partition"
+      @host2 = Host.create! :name => "anotherfullhost", :mac => "aabbecddee00", :ip => "123.05.02.04",
+                            :domain => domains(:mydomain) , :operatingsystem => Operatingsystem.first, :hostgroup => hostgroups(:common),
+                            :architecture => Architecture.first, :environment => Environment.first, :disk => "empty partition"
+      @parameter1 = HostParameter.create! :name => "some parameter", :value => "value", :reference_id => @host1.id
+      @parameter2 = HostParameter.create! :name => "some parameter", :value => "value", :reference_id => @host2.id
+    end
+    assert @parameter2.valid?
+  end
 
-    parameter1 = HostParameter.create :name => "some parameter", :value => "value", :reference_id => host1.id
-    parameter2 = HostParameter.create :name => "some parameter", :value => "value", :reference_id => host2.id
-    assert parameter2.valid?
+  def setup_user operation
+    @one = users(:one)
+    as_admin do
+      role = Role.find_or_create_by_name :name => "#{operation}_hosts"
+      role.permissions = ["#{operation}_hosts".to_sym]
+      @one.roles      = [role]
+      @one.domains    = []
+      @one.hostgroups = []
+      @one.user_facts = []
+      @one.save!
+    end
+    User.current = @one
   end
 
-end
+  test "user with create permissions should be able to create when permitted" do
+    setup_user "create"
+    as_admin do
+      @one.domains = [domains(:mydomain)]
+      @one.save!
+    end
+    record =  HostParameter.create :name => "dummy", :value => "value", :reference_id => hosts(:one).id
+    assert record.valid?
+    assert !record.new_record?
+  end
+
+  test "user with create permissions should not be able to create when not permitted" do
+    setup_user "create"
+    as_admin do
+      @one.hostgroups = [hostgroups(:common)]
+      @one.save!
+      hosts(:one).update_attribute :hostgroup, hostgroups(:unusual)
+    end
+    record =  HostParameter.create :name => "dummy", :value => "value", :reference_id => hosts(:one).id
+    assert record.valid?
+    assert record.new_record?
+  end
+
+  test "user with create permissions should be able to create when unconstrained" do
+    setup_user "create"
+    as_admin do
+      @one.domains = []
+    end
+    record =  HostParameter.create :name => "dummy", :value => "value", :reference_id => hosts(:one).id
+    assert record.valid?
+    assert !record.new_record?
+  end
+
+  test "user with view permissions should not be able to create" do
+    setup_user "view"
+    record =  HostParameter.create :name => "dummy", :value => "value", :reference_id => hosts(:one).id
+    assert record.valid?
+    assert record.new_record?
+  end
+
+  test "user with destroy permissions should be able to destroy" do
+    setup_user "destroy"
+    record =  HostParameter.first
+    assert record.destroy
+    assert record.frozen?
+  end
+
+  test "user with edit permissions should not be able to destroy" do
+    setup_user "edit"
+    record =  HostParameter.first
+    assert !record.destroy
+    assert !record.frozen?
+  end
 
+  test "user with edit permissions should be able to edit" do
+    setup_user "edit"
+    record      =  HostParameter.first
+    record.name = "renamed"
+    assert record.save
+  end
+
+  test "user with destroy permissions should not be able to edit" do
+    setup_user "destroy"
+    record      =  HostParameter.first
+    record.name = "renamed"
+    assert !record.save
+  end
+end
diff --git a/test/unit/host_test.rb b/test/unit/host_test.rb
index 0690d45..ee45d47 100644
--- a/test/unit/host_test.rb
+++ b/test/unit/host_test.rb
@@ -1,6 +1,10 @@
 require 'test_helper'
 
 class HostTest < ActiveSupport::TestCase
+  setup do
+    User.current = User.find_by_login "admin"
+  end
+
   test "should not save without a hostname" do
     host = Host.new
     assert !host.save
@@ -39,26 +43,31 @@ class HostTest < ActiveSupport::TestCase
     host = Host.create :name => "myfullhost", :mac => "aabbecddeeff", :ip => "123.05.02.03",
       :domain => Domain.find_or_create_by_name("company.com"), :operatingsystem => Operatingsystem.first,
       :architecture => Architecture.first, :environment => Environment.first, :disk => "empty partition"
-    puts host.errors.full_messages
+    if host.new_record?
+      puts host.errors.full_messages
+    end
     assert host.valid?
+    assert !host.new_record?
   end
 
   test "should import facts from yaml stream" do
     h=Host.new(:name => "sinn1636.lan")
     h.disk = "!" # workaround for now
-    assert h.importFacts(YAML::load(File.read(File.expand_path(File.dirname(__FILE__) + "/facts.yml"))))
+    assert true == h.importFacts(YAML::load(File.read(File.expand_path(File.dirname(__FILE__) + "/facts.yml"))))
   end
 
   test "should import facts from yaml of a new host" do
     assert Host.importHostAndFacts(File.read(File.expand_path(File.dirname(__FILE__) + "/facts.yml")))
   end
-  if SETTINGS[:unattended].nil? or SETTINGS[:unattended]
-    test "should not save if both ptable and disk are not defined" do
+
+  test "should not save if both ptable and disk are not defined" do
+    if SETTINGS[:unattended].nil? or SETTINGS[:unattended] == "true"
       host = Host.create :name => "myfullhost", :mac => "aabbecddeeff", :ip => "123.05.02.03",
         :domain => Domain.find_or_create_by_name("company.com"), :operatingsystem => Operatingsystem.first,
         :architecture => Architecture.first, :environment => Environment.first
-      assert true unless SETTINGS[:attended]
-      assert !host.valid?
+      assert host.new_record?
+    else
+      true
     end
   end
 
@@ -66,14 +75,14 @@ class HostTest < ActiveSupport::TestCase
     host = Host.create :name => "myfullhost", :mac => "aabbecddeeff", :ip => "123.05.02.03",
       :domain => Domain.find_or_create_by_name("company.com"), :operatingsystem => Operatingsystem.first,
       :architecture => Architecture.first, :environment => Environment.first, :ptable => Ptable.first
-    assert host.valid?
+    assert !host.new_record?
   end
 
   test "should save if disk is defined" do
     host = Host.create :name => "myfullhost", :mac => "aabbecddeeff", :ip => "123.05.02.03",
       :domain => Domain.find_or_create_by_name("company.com"), :operatingsystem => Operatingsystem.first,
       :architecture => Architecture.first, :environment => Environment.first, :disk => "aaa"
-    assert host.valid?
+    assert !host.new_record?
   end
 
   test "should import from external nodes output" do
@@ -103,4 +112,148 @@ class HostTest < ActiveSupport::TestCase
     assert host.disabled?
   end
 
+  def setup_user_and_host
+    @one            = users(:one)
+    @one.hostgroups = []
+    @one.domains    = []
+    @one.user_facts = []
+    @one.save!
+    @host           = hosts(:one)
+    @host.owner     = users(:two)
+    @host.save!
+    User.current    = @one
+  end
+
+  test "host cannot be edited without permission" do
+    setup_user_and_host
+    as_admin do
+      @one.roles = [Role.find_by_name("Viewer")]
+    end
+    assert !@host.update_attributes(:name => "blahblahblah")
+    assert_match /do not have permission/, @host.errors.full_messages.join("\n")
+  end
+
+  test "any host can be edited when permitted" do
+    setup_user_and_host
+    as_admin do
+      @one.roles      = [Role.find_by_name("Edit hosts")]
+    end
+    assert @host.update_attributes :name => "blahblahblah"
+    assert_no_match /do not have permission/, @host.errors.full_messages.join("\n")
+  end
+
+  test "hosts can be edited when domains permit" do
+    setup_user_and_host
+    as_admin do
+      @one.roles      = [Role.find_by_name("Edit hosts")]
+      @one.domains    = [Domain.find_by_name("mydomain.net")]
+    end
+    assert @host.update_attributes :name => "blahblahblah"
+    assert_no_match /do not have permission/, @host.errors.full_messages.join("\n")
+  end
+
+  test "hosts cannot be edited when domains deny" do
+    setup_user_and_host
+    as_admin do
+      @one.roles      = [Role.find_by_name("Edit hosts")]
+      @one.domains    = [Domain.find_by_name("yourdomain.net")]
+    end
+    assert !@host.update_attributes(:name => "blahblahblah")
+    assert_match /do not have permission/, @host.errors.full_messages.join("\n")
+  end
+
+  test "host cannot be created without permission" do
+    setup_user_and_host
+    as_admin do
+      @one.roles = [Role.find_by_name("Viewer")]
+    end
+    host = Host.create(:name => "blahblah", :mac => "aabbecddee19", :ip => "123.05.02.09",
+                       :domain => domains(:mydomain),  :operatingsystem => operatingsystems(:centos5_3),
+                       :architecture => architectures(:x86_64), :environment => environments(:production),
+                       :disk => "empty partition")
+    assert host.new_record?
+    assert_match /do not have permission/, host.errors.full_messages.join("\n")
+  end
+
+  test "any host can be created when permitted" do
+    setup_user_and_host
+    as_admin do
+      @one.roles = [Role.find_by_name("Create hosts")]
+    end
+    host = Host.create(:name => "blahblah", :mac => "aabbecddee19", :ip => "123.05.02.09",
+                       :domain => domains(:mydomain),  :operatingsystem => operatingsystems(:centos5_3),
+                       :architecture => architectures(:x86_64), :environment => environments(:production),
+                       :disk => "empty partition")
+    assert !host.new_record?
+    assert_no_match /do not have permission/, host.errors.full_messages.join("\n")
+  end
+
+  test "hosts can be created when hostgroups permit" do
+    setup_user_and_host
+    as_admin do
+      @one.roles      = [Role.find_by_name("Create hosts")]
+      @one.hostgroups = [Hostgroup.find_by_name("Common")]
+    end
+    host = Host.create(:name => "blahblah", :mac => "aabbecddee19", :ip => "123.05.02.09",
+                       :domain => domains(:mydomain),  :operatingsystem => operatingsystems(:centos5_3),
+                       :architecture => architectures(:x86_64), :environment => environments(:production),
+                       :disk => "empty partition", :hostgroup => Hostgroup.find_by_name("Common"))
+    assert !host.new_record?
+    assert_no_match /do not have permission/, host.errors.full_messages.join("\n")
+  end
+
+  test "hosts cannot be created when hostgroups deny" do
+    setup_user_and_host
+    as_admin do
+      @one.roles      = [Role.find_by_name("Create hosts")]
+      @one.hostgroups = [Hostgroup.find_by_name("Unusual")]
+    end
+    host = Host.create(:name => "blahblah", :mac => "aabbecddee19", :ip => "123.05.02.09",
+                       :domain => domains(:mydomain),  :operatingsystem => operatingsystems(:centos5_3),
+                       :architecture => architectures(:x86_64), :environment => environments(:production),
+                       :disk => "empty partition", :hostgroup => Hostgroup.find_by_name("Common"))
+    assert host.new_record?
+    assert_match /do not have permission/, host.errors.full_messages.join("\n")
+  end
+
+  test "host cannot be destroyed without permission" do
+    setup_user_and_host
+    as_admin do
+      @one.roles = [Role.find_by_name("Viewer")]
+    end
+    assert !@host.destroy
+    assert_match /do not have permission/, @host.errors.full_messages.join("\n")
+  end
+
+  test "any host can be destroyed when permitted" do
+    setup_user_and_host
+    as_admin do
+      @one.roles = [Role.find_by_name("Destroy hosts")]
+    end
+    assert @host.destroy
+    assert_no_match /do not have permission/, @host.errors.full_messages.join("\n")
+  end
+
+  test "hosts can be destroyed when ownership permits" do
+    setup_user_and_host
+    as_admin do
+      @one.roles = [Role.find_by_name("Destroy hosts")]
+      @host.update_attribute :owner,  users(:one)
+    end
+    assert @host.destroy
+    assert_no_match /do not have permission/, @host.errors.full_messages.join("\n")
+  end
+
+  test "hosts cannot be destroyed when ownership denies" do
+    setup_user_and_host
+    as_admin do
+      @one.roles   = [Role.find_by_name("Destroy hosts")]
+      @one.domains = [domains(:yourdomain)] # This does not grant access but does ensure that access is constrained
+      @host.owner  = users(:two)
+      @host.save!
+    end
+    assert !@host.destroy
+    assert_match /do not have permission/, @host.errors.full_messages.join("\n")
+  end
+
 end
diff --git a/test/unit/hostgroup_test.rb b/test/unit/hostgroup_test.rb
index 8659867..ca90921 100644
--- a/test/unit/hostgroup_test.rb
+++ b/test/unit/hostgroup_test.rb
@@ -1,26 +1,90 @@
 require 'test_helper'
 
 class HostgroupTest < ActiveSupport::TestCase
+  setup do
+    User.current = User.find_by_login "admin"
+  end
   test "name can't be blank" do
     host_group = Hostgroup.new :name => "  "
     assert host_group.name.strip.empty?
     assert !host_group.save
   end
-
+  
   test "name can't contain trailing white spaces" do
     host_group = Hostgroup.new :name => " all    hosts in the     world    "
     assert !host_group.name.strip.squeeze(" ").empty?
     assert !host_group.save
-
+    
     host_group.name.strip!.squeeze!(" ")
     assert host_group.save
   end
-
+  
   test "name must be unique" do
     host_group = Hostgroup.new :name => "some hosts"
     assert host_group.save
-
+    
     other_host_group = Hostgroup.new :name => "some hosts"
     assert !other_host_group.save
   end
+  
+  def setup_user operation
+    @one = users(:one)
+    as_admin do
+      role = Role.find_or_create_by_name :name => "#{operation}_hostgroup"
+      role.permissions = ["#{operation}_hostgroups".to_sym]
+      @one.roles = [role]
+      @one.save!
+    end
+    User.current = @one
+  end
+  
+  test "user with create permissions should be able to create" do
+    setup_user "create"
+    record =  Hostgroup.create :name => "dummy"
+    assert record.valid?
+    assert !record.new_record?
+  end
+  
+  test "user with view permissions should not be able to create" do
+    setup_user "view"
+    record =  Hostgroup.create :name => "dummy"
+    assert record.valid?
+    assert record.new_record?
+  end
+  
+  test "user with destroy permissions should be able to destroy" do
+    setup_user "destroy"
+    record =  Hostgroup.first
+    as_admin do
+      record.hosts = []
+    end
+    assert record.destroy
+    assert record.frozen?
+  end
+  
+  test "user with edit permissions should not be able to destroy" do
+    setup_user "edit"
+    record =  Hostgroup.first
+    assert !record.destroy
+    assert !record.frozen?
+  end
+  
+  test "user with edit permissions should be able to edit" do
+    setup_user "edit"
+    record      =  Hostgroup.first
+    record.name = "renamed"
+    assert record.save
+  end
+  
+  test "user with destroy permissions should not be able to edit" do
+    setup_user "destroy"
+    record      =  Hostgroup.first
+    record.name = "renamed"
+    as_admin do
+      record.hosts = []
+    end
+    assert !record.save
+    assert record.valid?
+  end
+  
 end
diff --git a/test/unit/media_test.rb b/test/unit/media_test.rb
index 89aebf3..2622dd8 100644
--- a/test/unit/media_test.rb
+++ b/test/unit/media_test.rb
@@ -1,6 +1,10 @@
 require 'test_helper'
 
 class MediaTest < ActiveSupport::TestCase
+  setup do
+    User.current = User.find_by_login "admin"
+  end
+
   test "name can't be blank" do
     media = Media.new :name => "   ", :path => "http://www.google.com"
     assert media.name.strip.empty?
@@ -52,4 +56,65 @@ class MediaTest < ActiveSupport::TestCase
 
     assert !media.destroy
   end
+
+  def setup_user operation
+    @one = users(:one)
+    as_admin do
+      role = Role.find_or_create_by_name :name => "#{operation}_medias"
+      role.permissions = ["#{operation}_medias".to_sym]
+      @one.roles = [role]
+      @one.save!
+    end
+    User.current = @one
+  end
+  
+  test "user with create permissions should be able to create" do
+    setup_user "create"
+    record =  Media.create :name => "dummy", :path => "http://hello"
+    assert record.valid?
+    assert !record.new_record?
+  end
+  
+  test "user with view permissions should not be able to create" do
+    setup_user "view"
+    record =  Media.create :name => "dummy", :path => "http://hello"
+    assert record.valid?
+    assert record.new_record?
+  end
+  
+  test "user with destroy permissions should be able to destroy" do
+    setup_user "destroy"
+    record =  Media.first
+    as_admin do
+      record.hosts = []
+    end
+    assert record.destroy
+    assert record.frozen?
+  end
+  
+  test "user with edit permissions should not be able to destroy" do
+    setup_user "edit"
+    record =  Media.first
+    assert !record.destroy
+    assert !record.frozen?
+  end
+  
+  test "user with edit permissions should be able to edit" do
+    setup_user "edit"
+    record      =  Media.first
+    record.name = "renamed"
+    assert record.save
+  end
+  
+  test "user with destroy permissions should not be able to edit" do
+    setup_user "destroy"
+    record      =  Media.first
+    record.name = "renamed"
+    as_admin do
+      record.hosts = []
+    end
+    assert !record.save
+    assert record.valid?
+  end
+
 end
diff --git a/test/unit/model_test.rb b/test/unit/model_test.rb
index a22279a..2331683 100644
--- a/test/unit/model_test.rb
+++ b/test/unit/model_test.rb
@@ -1,6 +1,10 @@
 require 'test_helper'
 
 class ModelTest < ActiveSupport::TestCase
+  setup do
+    User.current = User.find_by_login "admin"
+  end
+
   test "should have name" do
     m = Model.new
     assert !m.save
@@ -22,4 +26,65 @@ class ModelTest < ActiveSupport::TestCase
     m.hosts << host
     assert !m.destroy
   end
+
+  def setup_user operation
+    @one = users(:one)
+    as_admin do
+      role = Role.find_or_create_by_name :name => "#{operation}_models"
+      role.permissions = ["#{operation}_models".to_sym]
+      @one.roles = [role]
+      @one.save!
+    end
+    User.current = @one
+  end
+  
+  test "user with create permissions should be able to create" do
+    setup_user "create"
+    record =  Model.create :name => "dummy"
+    assert record.valid?
+    assert !record.new_record?
+  end
+  
+  test "user with view permissions should not be able to create" do
+    setup_user "view"
+    record =  Model.create :name => "dummy"
+    assert record.valid?
+    assert record.new_record?
+  end
+  
+  test "user with destroy permissions should be able to destroy" do
+    setup_user "destroy"
+    record =  Model.first
+    as_admin do
+      record.hosts = []
+    end
+    assert record.destroy
+    assert record.frozen?
+  end
+  
+  test "user with edit permissions should not be able to destroy" do
+    setup_user "edit"
+    record =  Model.first
+    assert !record.destroy
+    assert !record.frozen?
+  end
+  
+  test "user with edit permissions should be able to edit" do
+    setup_user "edit"
+    record      =  Model.first
+    record.name = "renamed"
+    assert record.save
+  end
+  
+  test "user with destroy permissions should not be able to edit" do
+    setup_user "destroy"
+    record      =  Model.first
+    record.name = "renamed"
+    as_admin do
+      record.hosts = []
+    end
+    assert !record.save
+    assert record.valid?
+  end
+
 end
